/* ************************************************************************** */
/*                                                                            */
/*                                                                            */
/*                                                                            */
/*                                                                            */
/*   By: ablanken <ablanken at student dot 42barcelona dot com                */
/*                                                                            */
/*   Created: foo bar by ablanken                                             */
/*   Updated: foo bar by Andrea Blanke                                        */
/*                                                                            */
/* ************************************************************************** */
#ifndef  STACK_H
# define STACK_H

# include <stdlib.h>

typedef struct s_stack_item
{
	int	val;
	int	pos;
	int	target_pos;
}	t_stack_item;

typedef struct s_stack
{
	int				size;
	int				top;
	t_stack_item	*items;
}	t_stack;

void	*stack_del(t_stack *s)
{
	free(s->items);
	free(s);
	return (NULL);
}

t_stack	*stack_new(int size)
{
	t_stack	*s;

	s = malloc(sizeof (t_stack));
	if (!s)
		return (NULL);
	s->items = malloc(size * sizeof (t_stack_item));
	if (!s->items)
		return (stack_del(s));
	s->size = size;
	s->top = 0;
	return (s);
}

int	stack_empty(const t_stack *s)
{
	return (s->top < 1);
}

int stack_full(const t_stack *s)
{
	return (s->top >= s->size);
}

t_stack_item	*stack_peek(const t_stack *s)
{
	if (stack_empty(s))
		return (NULL);
	return (&s->items[s->top - 1]);
}

t_stack_item	*stack_pop(t_stack *s)
{
	if (stack_empty(s))
		return (NULL);
	return (&s->items[--(s->top)]);
}

t_stack_item	*stack_push(t_stack *s, t_stack_item item)
{
	if (stack_full(s))
		return (NULL);
	s->items[s->top] = item;
	return (&s->items[s->top++]);
}

#endif
// vi: noet sw=4 ts=4:
